XBPS-INSTALL(1)

NAME
xbps-install - XBPS utility to (re)install and update packages

SYNOPSIS
xbps-install [OPTIONS] [PKG...]

DESCRIPTION
The xbps-install utility installs, reinstalls, downgrades and updates packages in the target root directory. The argument PKG is a package expression, which is explained in the PACKAGE EXPRESSION section.

If package is installed, it will be updated to the version available in repositories matching the PACKAGE EXPRESSION. Otherwise it will be installed, or reinstalled/downgraded if -f, --force option is set.

PACKAGE EXPRESSION
A package expression is a form to match a pattern; currently xbps supports 3 ways to specify them:

-   by package name, i.e: “foo”.

-   by exact package name and version, i.e: “foo-1.0_1”.

-   by specifying a package name and version separated by any of the following version comparators:

    < less than
    > greater than
    <= less or equal than
    >= greater or equal than

    Example: “foo>=2.0”.

The first repository matching the package expression wins.

OPTIONS

-A, --automatic
    Enables automatic installation mode, i.e. package will be treated as orphan if no package is depending on it directly. See --mode auto in xbps-pkgdb(1).

-C, --config dir
    Specifies a path to the XBPS configuration directory. If the first character is not '/' then it's a relative path of rootdir.

-c, --cachedir dir
    Specifies a path to the cache directory, where binary packages are stored. If the first character is not '/' then it's a relative path of rootdir.

-d, --debug
    Enables extra debugging shown to stderr.

-D, --download-only
    Only download packages to the cache, do not do any other installation steps. This may be useful for doing system upgrades while offline, or automatically downloading updates while leaving you with the option of still manually running the update.

-f, --force
    Force downgrade installation (if package version in repos is less than installed version), or reinstallation (if package version in repos is the same) to the target PKG, overwriting regular package files and symlinks (if they have been modified) but preserving configuration files. If -f is specified twice all files will be unpacked, even configuration files.

-h, --help
    Show the help message.

-I, --ignore-file-conflicts
    Ignore detected file conflicts in a transaction.

-i, --ignore-conf-repos
    Ignore repositories defined in configuration files. Only repositories specified in the command line via --repository will be used.

-M, --memory-sync
    For remote repositories, the data is fetched and stored in memory for the current operation. This ignores the existing on-disk repository archives in rootdir.

-n, --dry-run
    Dry-run mode. Show what actions would be done but don't do anything. The current output prints 6 arguments: "<pkgver> <action> <arch> <repository> <installedsize> <downloadsize>".

-R, --repository url
    Appends the specified repository to the top of the list. The url argument expects a URL to the repository for remote repositories or a path for local repositories. Note that remote repositories must be signed using xbps-rindex(1). This option can be specified multiple times.

--reproducible
    Enables reproducible mode in pkgdb. The install-date and repository package objects are not stored in pkgdb.

-r, --rootdir dir
    Specifies a full path for the target root directory.

-S, --sync
    Synchronize remote repository index files.

-U, --unpack-only
    If set, packages to be installed or upgraded in the transaction won't be configured, just unpacked. That means that those packages should be reconfigured via xbps-reconfigure(1).

-u, --update
    Performs a full system upgrade: all installed packages (except those on hold, see --mode hold in xbps-pkgdb(1)) will be updated to the greatest versions that were found in repositories.

-v, --verbose
    Enables verbose messages.

-y, --yes
    Assume yes to all questions and avoid interactive questions.

-V, --version
    Show the version information.

ENVIRONMENT

FORCE_IPV4
    Only use IPv4.

FORCE_IPV6
    Only use IPv6.

FTP_PASSIVE_MODE
    If set to anything else than no passive mode will be set for the ftp connection.

FTP_LOGIN
    User name to be set for ftp authentication.

FTP_PASSWORD
    Password to be set for ftp authentication.

FTP_PROXY
    Proxy URL that will be used to establish a ftp connection.

HTTP_PROXY
    Proxy URL that will be used to establish a http connection.

HTTP_PROXY_AUTH
    Sets the credentials to authenticate a user agent to a proxy server, in the form user:pass.

HTTP_AUTH
    Sets the credentials to authenticate to a http server, in the form user:pass.

HTTP_REFERER
    Overrides the default Referer http header.

HTTP_USER_AGENT
    Override the default User-Agent http header.

NO_PROXY
    Specifies a set of domains for which the proxy should not be consulted. The contents is a comma-, or space-separated list of domain names. A single asterisk will override all proxy variables and no transactions will be proxied.

SOCKS_PROXY
    Proxy URL that will be used to establish a socks connection.

SSL_NO_VERIFY_HOSTNAME
    Disables SSL/TLS hostname verification.

SSL_NO_VERIFY_PEER
    Disables SSL/TLS peer verification.

SSL_CA_CERT_FILE
    Overrides the default CA certificates file, by default set to /etc/ssl/certs/ca-certificates.crt.

SSL_CA_CERT_PATH
    Overrides the default CA certificates path, by default set to /etc/ssl/certs.

SSL_CLIENT_CERT_FILE
    Sets the SSL/TLS client verification certificate file.

SSL_CLIENT_KEY_FILE
    Sets the SSL/TLS client verification key file.

CONNECTION_TIMEOUT
    Sets connection timeout in milliseconds instead of default value of 5 minutes. When -1, waits indefinitely.

XBPS_ARCH
    Overrides uname(2) machine result with this value. Useful to install packages with a fake architecture.

XBPS_TARGET_ARCH
    Sets the target architecture to this value. This variable differs from XBPS_ARCH in that it allows you to install packages partially, because configuration phase is skipped (the target binaries might not be compatible with the native architecture).

FILES

/etc/xbps.d
    Default configuration directory.

/usr/share/xbps.d
    Default system configuration directory.

/var/db/xbps/.<pkgname>-files.plist
    Package files metadata.

/var/db/xbps/pkgdb-0.38.plist
    Default package database (0.38 format). Keeps track of installed packages and properties.

/var/cache/xbps
    Default cache directory to store downloaded binary packages.

SEE ALSO
xbps-checkvers(1), xbps-create(1), xbps-dgraph(1), xbps-digest(1), xbps-fbulk(1), xbps-fetch(1), xbps-pkgdb(1), xbps-query(1), xbps-reconfigure(1), xbps-remove(1), xbps-rindex(1), xbps-uchroot(1), xbps-uunshare(1), xbps.d(5)

AUTHORS
Juan Romero Pardines <xtraeme@gmail.com>

BUGS
Probably, but I try to make this not happen. Use it under your own responsibility and enjoy your life.

Report bugs at https://github.com/void-linux/xbps/issues